/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>

#include "pvfs2-server.h"
#include "job-time-mgr.h"
#include "server-config.h"

static int job_timer_do_work(PINT_server_op *s_op, job_status_s* js_p);
static int job_timer_error(PINT_server_op *s_op, job_status_s* js_p);

static union PINT_state_array_values ST_do_work[];
static union PINT_state_array_values ST_error[];

struct PINT_state_machine_s pvfs2_job_timer_sm = {
	.name = "pvfs2_job_timer_sm",
	.state_machine = ST_do_work
};

static union PINT_state_array_values ST_do_work[] = {
	{ .state_name = "do_work" },
	{ .parent_machine = &pvfs2_job_timer_sm },
	{ .flag = SM_NONE },
	{ .state_action = job_timer_do_work },
	{ .return_value = 0 },
	{ .next_state = ST_do_work },
	{ .return_value = -1 },
	{ .next_state = ST_error }
};

static union PINT_state_array_values ST_error[] = {
	{ .state_name = "error" },
	{ .parent_machine = &pvfs2_job_timer_sm },
	{ .flag = SM_NONE },
	{ .state_action = job_timer_error },
	{ .return_value = -1 },
	{ .flag = SM_TERMINATE }
};

# 39 "src/server/job-timer.sm"


/* job_timer_error()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static int job_timer_error(PINT_server_op *s_op, job_status_s* js_p)
{
    gossip_err("Error: stopping server job timer.\n");

    return(server_state_machine_complete(s_op));
}

/* job_timer_do_work()
 *
 * resets counters, updates metrices, etc- this is intended to be called
 * repeatedly on a regular interval
 */
static int job_timer_do_work(PINT_server_op *s_op, job_status_s* js_p)
{
    int ret = -1;
    job_id_t tmp_id;

#if 0
    PINT_STATE_DEBUG("do_work");
#endif

    /* look for expired jobs */
    ret = job_time_mgr_expire();
    if(ret < 0)
    {
	js_p->error_code = ret;
	return(1);
    }
	
    /* post another timer */
    return(job_req_sched_post_timer(1000,
	s_op,
	0,
	js_p,
	&tmp_id,
	server_job_context));
}




/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

