/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-storage.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "gossip.h"
#include "pvfs2-internal.h"

static int mgmt_remove_dspace(
    PINT_server_op *s_op, job_status_s *js_p);
static int mgmt_remove_cleanup(
    PINT_server_op *s_op, job_status_s *js_p);

extern PINT_server_trove_keys_s Trove_Common_Keys[];

static union PINT_state_array_values ST_prelude[];
static union PINT_state_array_values ST_remove_dspace[];
static union PINT_state_array_values ST_final_response[];
static union PINT_state_array_values ST_cleanup[];

struct PINT_state_machine_s pvfs2_mgmt_remove_object_sm = {
	.name = "pvfs2_mgmt_remove_object_sm",
	.state_machine = ST_prelude
};

static union PINT_state_array_values ST_prelude[] = {
	{ .state_name = "prelude" },
	{ .parent_machine = &pvfs2_mgmt_remove_object_sm },
	{ .flag = SM_JUMP },
	{ .nested_machine = &pvfs2_prelude_sm },
	{ .return_value = 0 },
	{ .next_state = ST_remove_dspace },
	{ .return_value = -1 },
	{ .next_state = ST_final_response }
};

static union PINT_state_array_values ST_remove_dspace[] = {
	{ .state_name = "remove_dspace" },
	{ .parent_machine = &pvfs2_mgmt_remove_object_sm },
	{ .flag = SM_NONE },
	{ .state_action = mgmt_remove_dspace },
	{ .return_value = -1 },
	{ .next_state = ST_final_response }
};

static union PINT_state_array_values ST_final_response[] = {
	{ .state_name = "final_response" },
	{ .parent_machine = &pvfs2_mgmt_remove_object_sm },
	{ .flag = SM_JUMP },
	{ .nested_machine = &pvfs2_final_response_sm },
	{ .return_value = -1 },
	{ .next_state = ST_cleanup }
};

static union PINT_state_array_values ST_cleanup[] = {
	{ .state_name = "cleanup" },
	{ .parent_machine = &pvfs2_mgmt_remove_object_sm },
	{ .flag = SM_NONE },
	{ .state_action = mgmt_remove_cleanup },
	{ .return_value = -1 },
	{ .flag = SM_TERMINATE }
};

# 58 "src/server/mgmt-remove-object.sm"


static int mgmt_remove_dspace(
    PINT_server_op *s_op, job_status_s *js_p)
{
    int ret = -PVFS_EINVAL;
    job_id_t j_id;
    struct server_configuration_s *user_opts = get_server_config_struct();

    gossip_debug(
        GOSSIP_SERVER_DEBUG, "Trying to mgmt_remove object %llu,%d\n",
        llu(s_op->req->u.mgmt_remove_object.handle),
        s_op->req->u.mgmt_remove_object.fs_id);

    ret = job_trove_dspace_remove(
        s_op->req->u.mgmt_remove_object.fs_id,
        s_op->req->u.mgmt_remove_object.handle,
        PINT_config_get_trove_sync_meta(
            user_opts, s_op->req->u.mgmt_remove_object.fs_id) |
        PINT_config_get_trove_meta_flags(
            user_opts, s_op->req->u.mgmt_remove_object.fs_id),
        s_op,
        0,
        js_p,
        &j_id,
        server_job_context);

    return ret;
}

static int mgmt_remove_cleanup(
    PINT_server_op *s_op, job_status_s *js_p)
{
    return(server_state_machine_complete(s_op));
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
